import 'package:flutter/material.dart';
import '../../../../../widget/centeredLeading.dart';
import '../../../../../widget/providerBridge.dart';
import '../abiturCalculatorStep.dart';
import '../abiturCalculatorView.dart';

import '../models/abiturCalculatorModel.dart';
import '../models/subject.dart';

class SelectGkStep extends AbiturCalculatorStep {
  SelectGkStep() : super(
    title: const Text('Grundkurse'),
    content: Builder(builder: (context) {
      var model = AbiturCalculatorModel.get(context);
      var gkSubjects = model.getSubjects().collection.where((e) => e.isGk()).toList();
      return Column(
        children: [
          AbiturCalculatorView.listSubjects(gkSubjects),
          TextButton(
            onPressed: () {
              ProviderBridge.toDialog(context, model, (context, value) {
                return AlertDialog(
                  title: const Text('Grundkurse'),
                  content: SingleChildScrollView(
                    child: Column(
                      mainAxisSize: MainAxisSize.min,
                      children: model.getSubjects().collection.map((e) {
                        return ListTile(
                          leading: CenteredLeading(Icon(e.icon)),
                          title: Text(e.displayName),
                          trailing: Checkbox(
                            value: e.isGk(),
                            onChanged: e.isGk() || e.canGk(model.getSubjects().collection) ? (value) {
                              e.unsafeGkToggle = value!;
                              model.update();
                            } : null,
                          ),
                        );
                      }).toList(),
                    ),
                  ),
                  actions: [
                    TextButton(
                      onPressed: () {
                        Navigator.of(context).pop();
                      },
                      child: const Text('Fertig'),
                    )
                  ],
                );
              });
            },
            child: Text(
                "Grundkurse ${gkSubjects.isEmpty ? "auswählen" : "ändern"}"),
          ),
        ],
      );
    }),
  );

  @override
  bool canGoNextStep(SubjectCollection subjects) {
    // TODO: implement canGoNextStepp
    throw UnimplementedError();
  }
}